/*
 *   Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.12.25 at 01:02:08 PM CET 
//

package net.ihe.gazelle.audit.message.desc;

import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * Java class for anonymous complex type.
 * 
 * <p>
 * The following schema fragment specifies the expected content contained within
 * this class.
 * 
 * <pre>
 * &lt;complexType&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base=&quot;{http://www.w3.org/2001/XMLSchema}anyType&quot;&gt;
 *       &lt;sequence&gt;
 *         &lt;element name=&quot;Document&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot;/&gt;
 *         &lt;element name=&quot;section&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot;/&gt;
 *         &lt;element name=&quot;generatorVersion&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot;/&gt;
 *         &lt;element name=&quot;Event&quot; type=&quot;{}EventIdentificationDesc&quot;/&gt;
 *         &lt;element name=&quot;ActiveParticipants&quot; type=&quot;{}ActiveParticipantDescription&quot; maxOccurs=&quot;unbounded&quot;/&gt;
 *         &lt;element name=&quot;AuditSource&quot; type=&quot;{}AuditSourceDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectIdentifications&quot; type=&quot;{}ParticipantObjectIdentificationDesc&quot; maxOccurs=&quot;unbounded&quot; minOccurs=&quot;0&quot;/&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = { "name", "oid", "affinityDomain", "document", "section", "schema",
		"generatorVersion", "event", "activeParticipants", "auditSource",
		"participantObjectIdentifications", "extraConstraintSpecifications" })
@XmlRootElement(name = "AuditMessageSpecification")
@Entity
@Name("auditMessageSpecification")
@Table(name = "am_audit_message_specification", schema = "public")
@SequenceGenerator(name = "am_audit_message_specification_sequence", sequenceName = "am_audit_message_specification_id_seq", allocationSize = 1)
public class AuditMessageSpecification extends AuditedAuditMessageSpec implements
		Comparable<AuditMessageSpecification>, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static final String FINDALL_QUERY = "SELECT e FROM AuditMessageSpecification e" ;

	@XmlTransient
	@Id
	@GeneratedValue(generator = "am_audit_message_specification_sequence", strategy = GenerationType.SEQUENCE)
	@NotNull
	@Column(name = "id")
	private Integer id;

	@XmlElement(required = true)
	@NotNull
	@Column(unique = true)
	protected String name;
	
	@XmlElement(required = true)
	@Column(unique = true)
	protected String oid;
	
	@XmlElement(required = true)
	@NotNull
	@Column(name="affinity_domain")
	protected String affinityDomain;

	@XmlElement(name = "Document", required = true)
	protected String document;

	@XmlElement(required = true)
	protected String section;

	@XmlElement(required = false)
	protected String schema;

	@XmlElement(required = true)
	protected String generatorVersion;
	
	@XmlAttribute(required = true)
	@Column
	protected Boolean isDicomCompatible;
	
	@XmlAttribute(required = true)
	@Column
	protected Boolean forceDicomCompatibility;
	
	@XmlAttribute(required = true)
	@Column
	protected Boolean isDeprecated = false;

	@XmlElement(name = "Event", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "event_id")
	protected EventIdentificationDesc event;

	@XmlElement(name = "ActiveParticipants", required = true)
	@OneToMany(cascade = { CascadeType.ALL })
	@JoinTable(name = "am_audit_message_specification_active_participants")
	protected List<ActiveParticipantDescription> activeParticipants;

	@XmlElement(name = "AuditSource", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "auditSource_id")
	protected AuditSourceDescription auditSource;

	@XmlElement(name = "ParticipantObjectIdentifications")
	@OneToMany(cascade = { CascadeType.ALL })
	@JoinTable(name = "am_audit_message_specification_participant_object_ident")
	protected List<ParticipantObjectIdentificationDesc> participantObjectIdentifications;

	@XmlElement(name = "ExtraConstraintSpecifications")
	@OneToMany(cascade = { CascadeType.ALL })
	@JoinTable(name = "am_audit_message_specification_constraint_specifications")
	protected List<ConstraintSpecification> extraConstraintSpecifications;

	public Boolean getForceDicomCompatibility() {
		return forceDicomCompatibility;
	}
	
	public boolean getForceDicomCompatibilityAsBoolean() {
		if (forceDicomCompatibility == null) return false;
		return forceDicomCompatibility;
	}

	public void setForceDicomCompatibility(Boolean forceDicomCompatibility) {
		this.forceDicomCompatibility = forceDicomCompatibility;
	}

	public Boolean getIsDeprecated() {
		return isDeprecated;
	}

	public void setIsDeprecated(Boolean isDeprecated) {
		this.isDeprecated = isDeprecated;
	}

	public Boolean getIsDicomCompatible() {
		return isDicomCompatible;
	}
	
	public boolean getIsDicomCompatibleAsBoolean() {
		boolean isDicomCompatible2 = this.getIsDicomCompatible()==null?false:this.getIsDicomCompatible();
		return isDicomCompatible2;
	}

	public void setIsDicomCompatible(Boolean isDicomCompatible) {
		this.isDicomCompatible = isDicomCompatible;
	}

	public List<ConstraintSpecification> getExtraConstraintSpecifications() {
		if (extraConstraintSpecifications == null) {
			extraConstraintSpecifications = new ArrayList<ConstraintSpecification>();
		}
		return extraConstraintSpecifications;
	}

	public void setExtraConstraintSpecifications(
			List<ConstraintSpecification> extraConstraintSpecifications) {
		this.extraConstraintSpecifications = extraConstraintSpecifications;
	}

	public String getSchema() {
		return schema;
	}

	public void setSchema(String schema) {
		this.schema = schema;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public void setActiveParticipants(
			List<ActiveParticipantDescription> activeParticipants) {
		this.activeParticipants = activeParticipants;
	}

	public void setParticipantObjectIdentifications(
			List<ParticipantObjectIdentificationDesc> participantObjectIdentifications) {
		this.participantObjectIdentifications = participantObjectIdentifications;
	}

	/**
	 * Gets the value of the document property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getDocument() {
		return document;
	}

	/**
	 * Sets the value of the document property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setDocument(String value) {
		this.document = value;
	}

	/**
	 * Gets the value of the section property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getSection() {
		return section;
	}

	/**
	 * Sets the value of the section property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setSection(String value) {
		this.section = value;
	}

	/**
	 * Gets the value of the generatorVersion property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getGeneratorVersion() {
		return generatorVersion;
	}

	/**
	 * Sets the value of the generatorVersion property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setGeneratorVersion(String value) {
		this.generatorVersion = value;
	}

	/**
	 * Gets the value of the event property.
	 * 
	 * @return possible object is {@link EventIdentificationDesc }
	 * 
	 */
	public EventIdentificationDesc getEvent() {
		return event;
	}

	/**
	 * Sets the value of the event property.
	 * 
	 * @param value
	 *            allowed object is {@link EventIdentificationDesc }
	 * 
	 */
	public void setEvent(EventIdentificationDesc value) {
		this.event = value;
	}

	/**
	 * Gets the value of the activeParticipants property.
	 * 
	 * <p>
	 * This accessor method returns a reference to the live list, not a
	 * snapshot. Therefore any modification you make to the returned list will
	 * be present inside the JAXB object. This is why there is not a
	 * <CODE>set</CODE> method for the activeParticipants property.
	 * 
	 * <p>
	 * For example, to add a new item, do as follows:
	 * 
	 * <pre>
	 * getActiveParticipants().add(newItem);
	 * </pre>
	 * 
	 * 
	 * <p>
	 * Objects of the following type(s) are allowed in the list
	 * {@link ActiveParticipantDescription }
     * @return the modifiable {@link ActiveParticipantDescription} list.
     *
	 */
	public List<ActiveParticipantDescription> getActiveParticipants() {
		if (activeParticipants == null) {
			activeParticipants = new ArrayList<ActiveParticipantDescription>();
		}
		return this.activeParticipants;
	}

	/**
	 * Gets the value of the auditSource property.
	 * 
	 * @return possible object is {@link AuditSourceDescription }
	 * 
	 */
	public AuditSourceDescription getAuditSource() {
		return auditSource;
	}

	/**
	 * Sets the value of the auditSource property.
	 * 
	 * @param value
	 *            allowed object is {@link AuditSourceDescription }
	 * 
	 */
	public void setAuditSource(AuditSourceDescription value) {
		this.auditSource = value;
	}

	/**
	 * Gets the value of the participantObjectIdentifications property.
	 * 
	 * <p>
	 * This accessor method returns a reference to the live list, not a
	 * snapshot. Therefore any modification you make to the returned list will
	 * be present inside the JAXB object. This is why there is not a
	 * <CODE>set</CODE> method for the participantObjectIdentifications
	 * property.
	 * 
	 * <p>
	 * For example, to add a new item, do as follows:
	 * 
	 * <pre>
	 * getParticipantObjectIdentifications().add(newItem);
	 * </pre>
	 * 
	 * 
	 * <p>
	 * Objects of the following type(s) are allowed in the list
	 * {@link ParticipantObjectIdentificationDesc }
     *
     * @return the modifiable {@link ParticipantObjectIdentificationDesc} list.
     *
	 */
	public List<ParticipantObjectIdentificationDesc> getParticipantObjectIdentifications() {
		if (participantObjectIdentifications == null) {
			participantObjectIdentifications = new ArrayList<ParticipantObjectIdentificationDesc>();
		}
		return this.participantObjectIdentifications;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result)
				+ ((activeParticipants == null) ? 0 : activeParticipants
						.hashCode());
		result = (prime * result)
				+ ((auditSource == null) ? 0 : auditSource.hashCode());
		result = (prime * result)
				+ ((document == null) ? 0 : document.hashCode());
		result = (prime * result) + ((event == null) ? 0 : event.hashCode());
		result = (prime * result)
				+ ((generatorVersion == null) ? 0 : generatorVersion.hashCode());
		result = (prime * result)
				+ ((participantObjectIdentifications == null) ? 0
						: participantObjectIdentifications.hashCode());
		result = (prime * result)
				+ ((section == null) ? 0 : section.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AuditMessageSpecification other = (AuditMessageSpecification) obj;
		if (activeParticipants == null) {
			if (other.activeParticipants != null) {
				return false;
			}
		} else if (!activeParticipants.equals(other.activeParticipants)) {
			return false;
		}
		if (auditSource == null) {
			if (other.auditSource != null) {
				return false;
			}
		} else if (!auditSource.equals(other.auditSource)) {
			return false;
		}
		if (document == null) {
			if (other.document != null) {
				return false;
			}
		} else if (!document.equals(other.document)) {
			return false;
		}
		if (event == null) {
			if (other.event != null) {
				return false;
			}
		} else if (!event.equals(other.event)) {
			return false;
		}
		if (generatorVersion == null) {
			if (other.generatorVersion != null) {
				return false;
			}
		} else if (!generatorVersion.equals(other.generatorVersion)) {
			return false;
		}
		if (participantObjectIdentifications == null) {
			if (other.participantObjectIdentifications != null) {
				return false;
			}
		} else if (!participantObjectIdentifications
				.equals(other.participantObjectIdentifications)) {
			return false;
		}
		if (section == null) {
			if (other.section != null) {
				return false;
			}
		} else if (!section.equals(other.section)) {
			return false;
		}
		return true;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Override
	public int compareTo(AuditMessageSpecification o) {
		if (this.getName() == null) {
			return -1;
		}
		if (o.getName() == null) {
			return 1;
		}
		return this.getName().compareTo(o.getName());
	}

	public String getOid() {
		return oid;
	}

	public void setOid(String oid) {
		this.oid = oid;
	}

	public String getAffinityDomain() {
		return affinityDomain;
	}

	public void setAffinityDomain(String affinityDomain) {
		this.affinityDomain = affinityDomain;
	}
}
